#if (__LSB_VERSION__ >= 50 )
#ifndef _GLIB_2_0_GIO_GDBUSMETHODINVOCATION_H_
#define _GLIB_2_0_GIO_GDBUSMETHODINVOCATION_H_

#include <stdarg.h>
#include <glib-2.0/glib.h>
#include <glib-2.0/glib-object.h>
#include <glib-2.0/gio/giotypes.h>

#ifdef __cplusplus
extern "C" {
#endif


#define G_TYPE_DBUS_METHOD_INVOCATION	(g_dbus_method_invocation_get_type ())
#define G_DBUS_METHOD_INVOCATION(o)	(G_TYPE_CHECK_INSTANCE_CAST ((o), G_TYPE_DBUS_METHOD_INVOCATION, GDBusMethodInvocation))
#define G_IS_DBUS_METHOD_INVOCATION(o)	(G_TYPE_CHECK_INSTANCE_TYPE ((o), G_TYPE_DBUS_METHOD_INVOCATION))



/* Function prototypes */

    extern GDBusConnection
	*g_dbus_method_invocation_get_connection(GDBusMethodInvocation *
						 invocation);
    extern const char
	*g_dbus_method_invocation_get_interface_name(GDBusMethodInvocation
						     * invocation);
    extern GDBusMessage
	*g_dbus_method_invocation_get_message(GDBusMethodInvocation *
					      invocation);
    extern const GDBusMethodInfo
	*g_dbus_method_invocation_get_method_info(GDBusMethodInvocation *
						  invocation);
    extern const char
	*g_dbus_method_invocation_get_method_name(GDBusMethodInvocation *
						  invocation);
    extern const char
	*g_dbus_method_invocation_get_object_path(GDBusMethodInvocation *
						  invocation);
    extern GVariant
	*g_dbus_method_invocation_get_parameters(GDBusMethodInvocation *
						 invocation);
    extern const char
	*g_dbus_method_invocation_get_sender(GDBusMethodInvocation *
					     invocation);
    extern GType g_dbus_method_invocation_get_type(void);
    extern gpointer
	g_dbus_method_invocation_get_user_data(GDBusMethodInvocation *
					       invocation);
    extern void
	g_dbus_method_invocation_return_dbus_error(GDBusMethodInvocation *
						   invocation,
						   const gchar *
						   error_name,
						   const gchar *
						   error_message);
    extern void g_dbus_method_invocation_return_error(GDBusMethodInvocation
						      * invocation,
						      GQuark domain,
						      gint code,
						      const gchar * format,
						      ...);
    extern void
	g_dbus_method_invocation_return_error_literal(GDBusMethodInvocation
						      * invocation,
						      GQuark domain,
						      gint code,
						      const gchar *
						      message);
    extern void
	g_dbus_method_invocation_return_error_valist(GDBusMethodInvocation
						     * invocation,
						     GQuark domain,
						     gint code,
						     const gchar * format,
						     va_list var_args);
    extern void
	g_dbus_method_invocation_return_gerror(GDBusMethodInvocation *
					       invocation,
					       const GError * error);
    extern void g_dbus_method_invocation_return_value(GDBusMethodInvocation
						      * invocation,
						      GVariant *
						      parameters);
    extern void
	g_dbus_method_invocation_return_value_with_unix_fd_list
	(GDBusMethodInvocation * invocation, GVariant * parameters,
	 GUnixFDList * fd_list);
    extern void g_dbus_method_invocation_take_error(GDBusMethodInvocation *
						    invocation,
						    GError * error);
#ifdef __cplusplus
}
#endif
#endif				/* protection */
#endif				/* LSB version */
